package tsuteto.spelunker.asm.entry;

import java.util.EnumSet;

import org.objectweb.asm.Opcodes;
import org.objectweb.asm.Type;
import org.objectweb.asm.tree.ClassNode;
import org.objectweb.asm.tree.InsnList;
import org.objectweb.asm.tree.MethodInsnNode;
import org.objectweb.asm.tree.MethodNode;
import org.objectweb.asm.tree.VarInsnNode;

import tsuteto.spelunker.asm.AsmPetitUtil;
import tsuteto.spelunker.asm.ITransformerEntry;
import cpw.mods.fml.relauncher.Side;

public class TEntryBlockDestroy implements ITransformerEntry, Opcodes
{
    @Override
    public EnumSet<Side> getSide()
    {
        return EnumSet.of(Side.CLIENT, Side.SERVER);
    }

    @Override
    public String getTargetClass()
    {
        return "net.minecraft.item.ItemInWorldManager";
    }

    @Override
    public String getTargetMethodDeobf()
    {
        return "removeBlock";
    }

    @Override
    public String getTargetMethodObf()
    {
        return "func_73079_d";
    }

    @Override
    public String getTargetMethodDesc()
    {
        return Type.getMethodDescriptor(Type.BOOLEAN_TYPE, Type.INT_TYPE, Type.INT_TYPE, Type.INT_TYPE);
    }

    @Override
    public void transform(MethodNode mnode, ClassNode cnode)
    {
        String block = AsmPetitUtil.getActualClass("net/minecraft/block/Block");

        InsnList overrideList = new InsnList();

        overrideList.add(new VarInsnNode(ALOAD, 0));
        overrideList.add(new VarInsnNode(ILOAD, 1));
        overrideList.add(new VarInsnNode(ILOAD, 2));
        overrideList.add(new VarInsnNode(ILOAD, 3));
        overrideList.add(new VarInsnNode(ALOAD, 4));
        overrideList.add(new MethodInsnNode(INVOKESTATIC,
                "tsuteto/spelunker/eventhandler/BlockDestroyHook",
                "onBlockDestroyed",
                "(L" + cnode.name + ";III" + "L" + block + ";)V"));

        mnode.instructions.insert(mnode.instructions.get(75), overrideList);
    }

}
