package tsuteto.spelunker.constants;

/**
 * Defines various parameters on Spelunker's difficulty
 * @author Tsuteto
 *
 */
public enum SpelunkerDifficulty
{
    PEACEFUL(0, 20, 15, 0.9D,  5.0D, 0, true),
    EASY    (1, 20, 10, 1.0D,  5.0D, 10, false),
    NORMAL  (2, 10,  6, 0.9D, 10.0D, 20, false),
    HARD    (3, 15,  4, 0.6D, 10.0D, 40, false);

    public int id;
    public int trials;
    public int lightLevel;
    public double chanceOfEnergy;
    public double spawnDensity;
    public int rarityNoItem;
    public boolean spawnInSight;

    SpelunkerDifficulty(int id, int trials, int lightLevel, double chanceOfEnergy, double spawnDensity, int rarityNoItem, boolean spawnInSight)
    {
        this.id = id;
        this.trials = trials;
        this.lightLevel = lightLevel;
        this.chanceOfEnergy = chanceOfEnergy;
        this.spawnDensity = spawnDensity;
        this.rarityNoItem = rarityNoItem;
        this.spawnInSight = spawnInSight;
    }

    public static SpelunkerDifficulty getSettings(int id)
    {
        for (SpelunkerDifficulty settings : SpelunkerDifficulty.values())
        {
            if (settings.id == id) return settings;
        }
        return null;
    }
}
