package tsuteto.spelunker.eventhandler;

import java.util.EnumSet;

import net.minecraft.client.Minecraft;
import tsuteto.spelunker.SpelunkerMod;
import tsuteto.spelunker.player.SpelunkerPlayerSP;
import tsuteto.spelunker.sound.ModSoundManager;
import cpw.mods.fml.client.FMLClientHandler;
import cpw.mods.fml.common.ITickHandler;
import cpw.mods.fml.common.TickType;

/**
 * Handles game ticks on client side
 *
 * @author Tsuteto
 *
 */
public class ClientTickHandler implements ITickHandler
{
    private SpelunkerMod mod;

    public ClientTickHandler(SpelunkerMod mod)
    {
        this.mod = mod;
    }

    @Override
    public void tickStart(EnumSet<TickType> type, Object... tickData)
    {
    }

    @Override
    public void tickEnd(EnumSet<TickType> type, Object... tickData)
    {
        Minecraft mc = FMLClientHandler.instance().getClient();
        if (mc.thePlayer == null) return;

        SpelunkerPlayerSP spelunker = SpelunkerMod.getSpelunkerPlayer(mc.thePlayer);
        if (spelunker == null) return;

        long worldtime = mc.theWorld.getWorldTime();

        if (type.equals(EnumSet.of(TickType.RENDER)))
        {
            mod.getScreenRenderer().renderGameOverlay(mc, mc.thePlayer, spelunker, worldtime);
        }
        else if (type.equals(EnumSet.of(TickType.CLIENT)))
        {
            if (!ModSoundManager.isReady()) ModSoundManager.init();
            ItemSpawnHandler.onClientTick(mc, spelunker, worldtime);
        }
    }

    @Override
    public EnumSet<TickType> ticks()
    {
        return EnumSet.of(TickType.RENDER, TickType.CLIENT);
    }

    @Override
    public String getLabel()
    {
        return null;
    }

}
