package tsuteto.spelunker.eventhandler;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraftforge.event.ForgeSubscribe;
import net.minecraftforge.event.entity.player.PlayerDestroyItemEvent;
import tsuteto.spelunker.SpelunkerMod;
import tsuteto.spelunker.damage.SpelunkerDamageSource;
import tsuteto.spelunker.player.ISpelunkerPlayer;

/**
 * Handles events on Spelunker
 *
 * @author Tsuteto
 *
 */
public class PlayerEventHandler
{
    @ForgeSubscribe
    public void onPlayerDestroyItem(PlayerDestroyItemEvent event)
    {
        ISpelunkerPlayer spelunker = SpelunkerMod.getSpelunkerPlayer(event.entityPlayer);
        if (spelunker != null && spelunker.isHardcore())
        {
            Item item = event.original.getItem();
            if (item != null && item.isDamageable())
            {
                EntityPlayer player = event.entityPlayer;
                player.attackEntityFrom(SpelunkerDamageSource.itemDestroy, 1.0f);
            }
        }
    }
}
