package tsuteto.spelunker.item;

import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import net.minecraft.client.renderer.texture.IconRegister;
import net.minecraft.util.Icon;
import net.minecraft.world.World;
import tsuteto.spelunker.player.SpelunkerPlayerMP;

public abstract class ItemAnimation extends SpelunkerItem
{
    protected Icon[] icons;
    protected int animationTick = 0;

    public ItemAnimation(int par1)
    {
        super(par1);
    }

    @Override
    public void animate()
    {
        this.itemIcon = this.icons[animationTick];
        animationTick = ++animationTick % this.getAnimationFlames();
    }

    public abstract int getAnimationFlames();
    
    @SideOnly(Side.CLIENT)
    @Override
    public void registerIcons(IconRegister par1IconRegister)
    {
        this.icons = new Icon[this.getAnimationFlames()];
        for (int i = 0; i < this.icons.length; i++)
        {
            this.icons[i] = par1IconRegister.registerIcon(this.getUnlocalizedName().replace("item.", "") + "_" + i);
        }
        this.itemIcon = this.icons[0];
    }
}
