package tsuteto.spelunker.util;

import java.lang.reflect.Field;

public class FieldAccessor<T>
{
    private final Field fld;

    public FieldAccessor(Field fld)
    {
        this.fld = fld;
        fld.setAccessible(true);
    }

    public T get(Object obj) throws IllegalArgumentException, IllegalAccessException
    {
        return (T)fld.get(obj);
    }

    public void set(Object obj, T val) throws IllegalArgumentException, IllegalAccessException
    {
        fld.set(obj, val);
    }
}
